import { world, Location } from "@minecraft/server"

//armor.equip_...generic, leather, iron, diamond, netherite

//generic gear (not metal nor leather)
const genericEquipmentArray = [
    "runecraft:forest_green_party_hat",
    "runecraft:dark_green_party_hat",
    "runecraft:royal_blue_party_hat",
    "runecraft:silver_party_hat",
    "runecraft:purple_party_hat",
    "runecraft:blood_red_party_hat",
    "runecraft:panda_head_brown",
    "runecraft:panda_head",
    "runecraft:witch_head",
    "runecraft:panda_head_brown",
    "runecraft:llama_head_cream",
    "runecraft:llama_head_brown",
    "runecraft:llama_head_gray",
    "runecraft:llama_head_white"
]

//plays leather equip sounds
//Leather
const leatherEquipmentArray = [
    "runecraft:leather_body",
    "runecraft:leather_cap",
    "runecraft:leather_leggings",
    "runecraft:leather_boots",
    "runecraft:graceful_leggings",
    "runecraft:graceful_hood",
    "runecraft:graceful_top",
    "runecraft:graceful_boots",
    "runecraft:fancy_boots",
    "runecraft:fighting_boots",
    "runecraft:agility_skillcape",
    "runecraft:attack_skillcape",
    "runecraft:constitution_skillcape",
    "runecraft:defense_skillcape",
    "runecraft:digging_skillcape",
    "runecraft:farming_skillcape",
    "runecraft:mining_skillcape",
    "runecraft:prayer_skillcape",
    "runecraft:ranged_skillcape",
    "runecraft:thieving_skillcape",
    "runecraft:woodcutting_skillcape",
    "runecraft:rogue_boots",
    "runecraft:rogue_mask",
    "runecraft:rogue_top",
    "runecraft:rogue_trousers"
]

//plays iron equip sounds
//Bronze, Iron, Black
const metalEquipmentArrayLow = [
    "runecraft:black_boots_g",
    "runecraft:black_boots_t",
    "runecraft:black_boots",
    "runecraft:black_helm_g",
    "runecraft:black_helm_t",
    "runecraft:black_helm",
    "runecraft:black_platebody_g",
    "runecraft:black_platebody_t",
    "runecraft:black_platebody",
    "runecraft:black_platelegs_g",
    "runecraft:black_platelegs_t",
    "runecraft:black_platelegs",
    "runecraft:bronze_boots_g",
    "runecraft:bronze_boots_t",
    "runecraft:bronze_boots",
    "runecraft:bronze_helm_g",
    "runecraft:bronze_helm_t",
    "runecraft:bronze_helm",
    "runecraft:bronze_platebody_g",
    "runecraft:bronze_platebody_t",
    "runecraft:bronze_platebody",
    "runecraft:bronze_platelegs_g",
    "runecraft:bronze_platelegs_t",
    "runecraft:bronze_platelegs",
    "runecraft:iron_boots_g",
    "runecraft:iron_boots_t",
    "runecraft:iron_boots",
    "runecraft:iron_helm_g",
    "runecraft:iron_helm_t",
    "runecraft:iron_helm",
    "runecraft:iron_platebody_g",
    "runecraft:iron_platebody_t",
    "runecraft:iron_platebody",
    "runecraft:iron_platelegs_g",
    "runecraft:iron_platelegs_t",
    "runecraft:iron_platelegs"
]

//plays diamond sounds
//Steel
const metalEquipmentArrayMed = [
    "runecraft:steel_boots_g",
    "runecraft:steel_boots_t",
    "runecraft:steel_boots",
    "runecraft:steel_helm_g",
    "runecraft:steel_helm_t",
    "runecraft:steel_helm",
    "runecraft:steel_platebody_g",
    "runecraft:steel_platebody_t",
    "runecraft:steel_platebody",
    "runecraft:steel_platelegs_g",
    "runecraft:steel_platelegs_t",
    "runecraft:steel_platelegs"
]

//plays netherite equip sounds
//Rune, Adamant, Mithril
const metalEquipmentArrayHigh = [
    "runecraft:adamant_boots_g",
    "runecraft:adamant_boots_t",
    "runecraft:adamant_boots",
    "runecraft:adamant_helm_g",
    "runecraft:adamant_helm_t",
    "runecraft:adamant_helm",
    "runecraft:adamant_platebody_g",
    "runecraft:adamant_platebody_t",
    "runecraft:adamant_platebody",
    "runecraft:adamant_platelegs_g",
    "runecraft:adamant_platelegs_t",
    "runecraft:adamant_platelegs",
    "runecraft:mithril_boots_g",
    "runecraft:mithril_boots_t",
    "runecraft:mithril_boots",
    "runecraft:mithril_helm_g",
    "runecraft:mithril_helm_t",
    "runecraft:mithril_helm",
    "runecraft:mithril_platebody_g",
    "runecraft:mithril_platebody_t",
    "runecraft:mithril_platebody",
    "runecraft:mithril_platelegs_g",
    "runecraft:mithril_platelegs_t",
    "runecraft:mithril_platelegs",
    "runecraft:rune_boots_g",
    "runecraft:rune_boots_t",
    "runecraft:rune_boots",
    "runecraft:rune_helm_g",
    "runecraft:rune_helm_t",
    "runecraft:rune_helm",
    "runecraft:rune_platebody_g",
    "runecraft:rune_platebody_t",
    "runecraft:rune_platebody",
    "runecraft:rune_platelegs_g",
    "runecraft:rune_platelegs_t",
    "runecraft:rune_platelegs"
]

const arrayOfArrays = [
    "genericEquipmentArray",
    "leatherEquipmentArray",
    "metalEquipmentArrayLow",
    "metalEquipmentArrayMed",
    "metalEquipmentArrayHigh"
]
world.events.beforeItemUse.subscribe((eventData) => {
    const item = eventData.item.typeId;
    const playerLocation = new Location (Math.floor(eventData.source.location.x), Math.floor(eventData.source.location.y), Math.floor(eventData.source.location.z));
    for(let i = 0; i < genericEquipmentArray.length; i++) {
        if(genericEquipmentArray[i] == item) {
            world.playSound("armor.equip_generic",{location:playerLocation});
            return;
        }
    }
    for(let i = 0; i < leatherEquipmentArray.length; i++) {
        if(leatherEquipmentArray[i] == item) {
            world.playSound("armor.equip_leather",{location:playerLocation});
            return;
        }
    };
    for(let i = 0; i < metalEquipmentArrayLow.length; i++) {
        if(metalEquipmentArrayLow[i] == item) {
            world.playSound("armor.equip_iron",{location:playerLocation});
            return;
        }
    };
    for(let i = 0; i < metalEquipmentArrayMed.length; i++) {
        if(metalEquipmentArrayMed[i] == item) {
            world.playSound("armor.equip_diamond",{location:playerLocation});
            return;
        }
    };
    for(let i = 0; i < metalEquipmentArrayHigh.length; i++) {
        if(metalEquipmentArrayHigh[i] == item) {
            world.playSound("armor.equip_netherite",{location:playerLocation});
            return;
        }
    }
})
