import { world } from "@minecraft/server"

//combat calculations
world.events.entityHurt.subscribe((eventData) => {

    if (eventData.damageSource.damagingEntity) {

        if (eventData.damageSource.damagingEntity.typeId == "minecraft:player") {

            let player = eventData.damageSource.damagingEntity;

            if (player.scoreboard.getScore(world.scoreboard.getObjective('gamemode')) <= 2) {

                const currentHealth = eventData.hurtEntity.getComponent("minecraft:health").current;
                let actualDamage = eventData.damage;
                //Check for entity health less than 0. Since entity health can be a negative value, 
                //we add that value to the players current damage to get the real damage value.
                if (currentHealth < 0) {
                    actualDamage = Math.ceil(eventData.damage + currentHealth);
                }
                //melee xp calculations
                if (eventData.damageSource.cause == "entityAttack" && player.hasTag("noAttackXP") == false) {
                    const attackExperience = actualDamage * 7;
                    const defenseExperience = actualDamage * 5;
                    const constitutionExperience = actualDamage * 4;

                    player.scoreboard.setScore(world.scoreboard.getObjective('attack_xp_c'), player.scoreboard.getScore(world.scoreboard.getObjective('attack_xp_c')) + attackExperience);
                    player.scoreboard.setScore(world.scoreboard.getObjective('tot_attack_xp'), player.scoreboard.getScore(world.scoreboard.getObjective('tot_attack_xp')) + attackExperience);
                    player.scoreboard.setScore(world.scoreboard.getObjective('def_xp_c'), player.scoreboard.getScore(world.scoreboard.getObjective('def_xp_c')) + defenseExperience);
                    player.scoreboard.setScore(world.scoreboard.getObjective('tot_def_xp'), player.scoreboard.getScore(world.scoreboard.getObjective('tot_def_xp')) + defenseExperience);
                    player.scoreboard.setScore(world.scoreboard.getObjective('const_xp_c'), player.scoreboard.getScore(world.scoreboard.getObjective('const_xp_c')) + constitutionExperience);
                    player.scoreboard.setScore(world.scoreboard.getObjective('tot_const_xp'), player.scoreboard.getScore(world.scoreboard.getObjective('tot_const_xp')) + constitutionExperience);
                    player.scoreboard.setScore(world.scoreboard.getObjective('total_xp'), player.scoreboard.getScore(world.scoreboard.getObjective('total_xp')) + attackExperience + defenseExperience + constitutionExperience);
                }

                //ranged xp calculations
                else if (eventData.damageSource.cause == "projectile" && player.hasTag("noRangedXP") == false) {
                    if (eventData.damageSource.damagingProjectile.velocity.y == 0) {
                        //do nothing, player has built a monkey brain trident farm and will not get XP from this :]
                    }
                    else {
                        const rangedExperience = actualDamage * 8;
                        const defenseExperience = actualDamage * 4;
                        const constitutionExperience = actualDamage * 4;

                        player.scoreboard.setScore(world.scoreboard.getObjective('ranged_xp_c'), player.scoreboard.getScore(world.scoreboard.getObjective('ranged_xp_c')) + rangedExperience);
                        player.scoreboard.setScore(world.scoreboard.getObjective('tot_ranged_xp'), player.scoreboard.getScore(world.scoreboard.getObjective('tot_ranged_xp')) + rangedExperience);
                        player.scoreboard.setScore(world.scoreboard.getObjective('def_xp_c'), player.scoreboard.getScore(world.scoreboard.getObjective('def_xp_c')) + defenseExperience);
                        player.scoreboard.setScore(world.scoreboard.getObjective('tot_def_xp'), player.scoreboard.getScore(world.scoreboard.getObjective('tot_def_xp')) + defenseExperience);
                        player.scoreboard.setScore(world.scoreboard.getObjective('const_xp_c'), player.scoreboard.getScore(world.scoreboard.getObjective('const_xp_c')) + constitutionExperience);
                        player.scoreboard.setScore(world.scoreboard.getObjective('tot_const_xp'), player.scoreboard.getScore(world.scoreboard.getObjective('tot_const_xp')) + constitutionExperience);
                        player.scoreboard.setScore(world.scoreboard.getObjective('total_xp'), player.scoreboard.getScore(world.scoreboard.getObjective('total_xp')) + rangedExperience + defenseExperience + constitutionExperience);
                    }
                }
            }
        }
    }
})